.386
.model flat, stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\ole32.inc
include \masm32\include\oleaut32.inc
include \masm32\include\Comctl32.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\Comctl32.lib
includelib \masm32\lib\masm32.lib

S macro	data:VARARG 
	LOCAL Buff
.data
	Buff db data, 0h
.code
	exitm <offset Buff>
endm

.const
	BITMAP_W	EQU		110
	BITMAP_H	EQU		115
	BITMAP_X	EQU		2
	BITMAP_Y	EQU		2
	BITMAP_FRISTID	EQU		1001
	BITMAP_COUNT	EQU		10

.data?
	MouseInRectFlag	BOOL		?
	mouseX		dd		?
	mouseY		dd		?
	x		dd		?
	y		dd		?
	dwDirect	dd		?  ;0-Left,1-Right,2-Up,3-Down
	num		dd		?

	hInstance	HINSTANCE	?
	hBitmap_1	dd		?
	hBitmap_2	dd		?
	Bitmapbuf	db		4*BITMAP_COUNT dup(?)
	hStatic		dd		?
	hSpeed		dd		?
	hStep		dd		?
	hTrk1		dd		?
	hTrk2		dd		?
	dwSpeed		dd		?
	idwStep		db		8 DUP (?)
	dwStep		dd		?
	idwSpeed	db		8 DUP (?)
	Testbuf		db		128 DUP (?)

.code

cTrackbar proc hParent:DWORD,_x:DWORD,_y:DWORD,_w:DWORD,_h:DWORD,ID:DWORD
	
	invoke CreateWindowEx,0h,\
		S("msctls_trackbar32"),0,050000000h,_x,_y,_w,_h,\
		hParent,ID,hInstance,NULL
	ret

cTrackbar endp

cStatic proc hParent:DWORD,lpText:DWORD,_x:DWORD,_y:DWORD,_w:DWORD,_h:DWORD,ID:DWORD
	LOCAL hFont :DWORD
	invoke  CreateFont,14,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE, \
		    ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, \
		    DEFAULT_QUALITY,DEFAULT_PITCH, S("MS Sans Serif")
	mov	hFont, eax
	
	invoke CreateWindowEx,000020000h,\
		S("Static"),lpText,050000001h,_x,_y,_w,_h,\
		hParent,ID,hInstance,NULL
	push	eax
	invoke	SendMessage,eax,WM_SETFONT,hFont, 0
	pop	eax
	ret

cStatic endp

AutoCheck proc hParent:DWORD,lpText:DWORD,sStyle:DWORD,_x:DWORD,_y:DWORD,_w:DWORD,_h:DWORD,ID:DWORD
	LOCAL hFont :DWORD

	invoke  CreateFont,14,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE, \
		    ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, \
		    DEFAULT_QUALITY,DEFAULT_PITCH, S("MS Sans Serif")
	mov	hFont, eax
	
	invoke CreateWindowEx,0,\
		S("BUTTON"),lpText,sStyle,_x,_y,_w,_h,\
		hParent,ID,hInstance,NULL
	push	eax
	invoke	SendMessage,eax,WM_SETFONT,hFont, 0
	pop	eax
	ret

AutoCheck endp

TopXY proc wDim:DWORD, sDim:DWORD

	shr sDim, 1     
	shr wDim, 1     
	mov eax, wDim   
	sub sDim, eax   

	mov eax, sDim
	ret

TopXY endp

StcProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	Local ps:PAINTSTRUCT
	Local hdc:HDC
	Local mdc:HDC
	
	.if uMsg == WM_PAINT
		invoke	BeginPaint, hStatic,addr ps
		mov	hdc, eax
		invoke	CreateCompatibleDC, eax
		mov	mdc, eax
		
		.if	dwDirect==0	;left
			invoke	SelectObject, mdc, hBitmap_1
			invoke	BitBlt, hdc, BITMAP_X, BITMAP_X, BITMAP_W, BITMAP_H, mdc, x, 0, SRCCOPY

			invoke	SelectObject,mdc,hBitmap_2
			mov	ebx,x
			sub	ebx,BITMAP_W
			invoke	BitBlt,hdc,BITMAP_X,BITMAP_Y,BITMAP_W,BITMAP_H,mdc,ebx,0,SRCCOPY
		.elseif dwDirect==1	;right
			invoke	SelectObject, mdc, hBitmap_1
			mov	ebx,x
			sub	ebx,BITMAP_W
			invoke	BitBlt, hdc, BITMAP_X, BITMAP_X, BITMAP_W, BITMAP_H, mdc, ebx, 0, SRCCOPY

			invoke	SelectObject,mdc,hBitmap_2
			invoke	BitBlt,hdc,BITMAP_X,BITMAP_Y,BITMAP_W,BITMAP_H,mdc,x,0,SRCCOPY
		.elseif dwDirect==2	;Up
			invoke	SelectObject, mdc, hBitmap_1
			invoke	BitBlt, hdc, BITMAP_X, BITMAP_X, BITMAP_W, BITMAP_H, mdc, 0, y, SRCCOPY

			invoke	SelectObject,mdc,hBitmap_2
			mov	ebx,y
			sub	ebx,BITMAP_H
			invoke	BitBlt,hdc,BITMAP_X,BITMAP_Y,BITMAP_W,BITMAP_H,mdc,0,ebx,SRCCOPY
		.elseif dwDirect==3	;Down
			invoke	SelectObject, mdc, hBitmap_1
			mov	ebx,y
			sub	ebx,BITMAP_H
			invoke	BitBlt, hdc, BITMAP_X, BITMAP_X, BITMAP_W, BITMAP_H, mdc,0,ebx,SRCCOPY

			invoke	SelectObject,mdc,hBitmap_2
			invoke	BitBlt,hdc,BITMAP_X,BITMAP_Y,BITMAP_W,BITMAP_H,mdc,0,y,SRCCOPY
		.endif
		invoke	DeleteDC, mdc
		invoke	EndPaint, hStatic, addr ps
		xor eax,eax
		ret
	.endif
	invoke GetWindowLong,hStatic,GWL_USERDATA
	invoke CallWindowProc,eax,hWin,uMsg,wParam,lParam
	ret
StcProc endp

WndProc proc uses ecx edx esi edi hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL lpRect:RECT	
	LOCAL mdr:POINT	
	
	.if uMsg==WM_CREATE
		mov	dwDirect,0
		mov	dwStep,1
		mov	dwSpeed,50
		
		invoke	AutoCheck,hWnd,S('Left'),050030009h,2,19,50,12,2001
		invoke	AutoCheck,hWnd,S('Right'),050010009h,127,19,45,12,2002
		invoke	AutoCheck,hWnd,S('Up'),050010009h,65,2,50,12,2003
		invoke	AutoCheck,hWnd,S('Down'),050010009h,65,36,50,12,2004
		invoke	CheckDlgButton,hWnd,2001,BST_CHECKED
		invoke	cTrackbar,hWnd,2,71,170,20,2005
		mov	hTrk1,eax
   		invoke	SendMessage,hTrk1,TBM_SETRANGE,1,06E0001h
		invoke	SendMessage,hTrk1,TBM_SETTICFREQ,2,1
		invoke	SendMessage,hTrk1,TBM_SETPAGESIZE,0,1
		invoke	SendMessage,hTrk1,TBM_SETPOS,18,10
		
		invoke	cTrackbar,hWnd,2,110,170,20,2006
		mov	hTrk2,eax
   		invoke	SendMessage,hTrk2,TBM_SETRANGE,1,07D0000Ah
		invoke	SendMessage,hTrk2,TBM_SETTICFREQ,2,1
		invoke	SendMessage,hTrk2,TBM_SETPAGESIZE,0,1
		invoke	SendMessage,hTrk2,TBM_SETPOS,18,50
		invoke	cStatic,hWnd,S('Step'),60,54,60,16,2007
		mov	hStep,eax
		invoke	cStatic,hWnd,S('Speed'),60,92,60,16,2008
		mov	hSpeed,eax
		invoke	cStatic,hWnd,0,175,6,116,121,2007
		mov	hStatic,eax
		invoke	SetWindowLong,hStatic,GWL_WNDPROC,offset StcProc
		invoke	SetWindowLong,hStatic,GWL_USERDATA,eax
		
		lea	edi,Bitmapbuf
		xor	ebx,ebx
		.repeat
			mov	ecx,BITMAP_FRISTID
			add	ecx,ebx
			invoke 	BitmapFromResource,hInstance,ecx
			mov	[edi+4*ebx],eax
			inc ebx
		.until ebx==BITMAP_COUNT
		mov	num,-1
		inc	num
		lea	esi,Bitmapbuf
		mov	ecx,num
		mov	ebx,dword ptr[esi+4*ecx]
		mov	edx,dword ptr[esi+4*ecx+4]
		mov	hBitmap_1,ebx
		mov	hBitmap_2,edx
		inc	num
		invoke	SetTimer, hWnd, 1, dwSpeed, 0

	.elseif uMsg==WM_TIMER
		
		.if	dwDirect==0	;left
			mov	eax, x
			cmp	MouseInRectFlag, TRUE
			jz	@F
			add	eax, dwStep
		@@:	
			cmp	eax, BITMAP_W
			jle	@x
		.elseif dwDirect==1	;right
			mov	eax, x
			cmp	MouseInRectFlag, TRUE
			jz	@F
			sub	eax, dwStep
		@@:	
			cmp	eax, 0
			jge	@x
		
		.elseif dwDirect==2	;Up
			mov	eax, y
			cmp	MouseInRectFlag, TRUE
			jz	@F
			add	eax, dwStep
		@@:	
			cmp	eax, BITMAP_H
			jle	@y
		.elseif dwDirect==3	;Down
			mov	eax, y
			cmp	MouseInRectFlag, TRUE
			jz	@F
			sub	eax, dwStep
		@@:	
			cmp	eax, 0
			jge	@y
		.endif
		
		mov	ebx,hBitmap_2
		mov	hBitmap_1,ebx
		
		lea	esi,Bitmapbuf
		inc	num
		mov	ecx,num
		mov	edx,dword ptr[esi+4*ecx]
		mov	hBitmap_2,edx

		cmp	num,BITMAP_COUNT-1       
		jne	@1
		mov	num,-1
@1:
		.if	dwDirect==0	;left
			sub	eax,BITMAP_W
		.elseif dwDirect==1	;right
			add	eax,BITMAP_W
		.elseif dwDirect==2	;Up
			sub	eax,BITMAP_H
			jmp	@y
		.elseif dwDirect==3	;Down
			add	eax,BITMAP_H
			jmp	@y
		.endif
@x:	
		mov	x, eax
		jmp	@F
@y:	
		mov	y, eax
@@:		invoke	InvalidateRect,hStatic,NULL,NULL
	.elseif uMsg==WM_COMMAND
		mov	eax,wParam
		and	eax,0ffffh
		.if eax==2001	;left
			mov	dwDirect,0
		.elseif eax==2002	;right
			mov	dwDirect,1
		.elseif eax==2003	;Up
			mov	dwDirect,2
		.elseif eax==2004	;Down
			mov	dwDirect,3
		.endif
	.elseif uMsg == WM_HSCROLL
		mov eax,wParam
		and eax,0ffffh
   		.if eax == TB_THUMBTRACK || TB_PAGEUP || TB_PAGEDOWN || TB_THUMBPOSITION
			mov eax,lParam
			.if eax == hTrk1			
				invoke	SendMessage,hTrk1,TBM_GETPOS,0,0
				mov	dwStep,eax
				invoke	wsprintf,addr idwStep,S("%u% pix"),dwStep
				invoke	SetWindowText,hStep,addr idwStep
			.elseif eax ==	hTrk2			
				invoke	SendMessage,hTrk2,TBM_GETPOS,0,0
				mov	dwSpeed,eax
				invoke	wsprintf,addr idwSpeed,S("%u% ms"),dwSpeed
				invoke	SetWindowText,hSpeed,addr idwSpeed
				invoke	KillTimer, hWnd, 1
				invoke	SetTimer, hWnd, 1, dwSpeed, 0
			.endif
		.endif
	.elseif uMsg==WM_MOUSEMOVE
		invoke	RtlZeroMemory,addr lpRect,sizeof lpRect
		invoke	GetWindowRect,hStatic,addr lpRect	
		invoke	ScreenToClient,hWnd,addr lpRect
		mov	ax, word ptr lParam
		mov	mdr.x, eax
		mov	ax, word ptr lParam+2
		mov	mdr.y, eax
		invoke	PtInRect,addr lpRect,mdr.x,mdr.y
		.if	eax==0
			mov	MouseInRectFlag,FALSE
		.else
			mov	MouseInRectFlag,TRUE
		.endif
	.elseif uMsg==WM_CLOSE
		invoke	KillTimer, hWnd, 1
		invoke	PostMessage,hWnd,WM_DESTROY,NULL,NULL
	.elseif uMsg==WM_DESTROY
		invoke	PostQuitMessage,NULL
	.else
		invoke  DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
	.endif
	xor eax,eax
	ret

WndProc endp

WinMain proc uses esi arg:dword
        LOCAL WndClass:WNDCLASSA 
        LOCAL Msg:MSG
 	LOCAL x_:DWORD
	LOCAL y_:DWORD
	LOCAL w_:DWORD
	LOCAL h_:DWORD 
	LOCAL hWnd:DWORD 
      
        xor     esi, esi           
        mov     WndClass.style, CS_HREDRAW or CS_VREDRAW
        mov     WndClass.lpfnWndProc, offset WndProc
        mov     WndClass.cbClsExtra, esi
        mov     WndClass.cbWndExtra, esi
	push	hInstance
	pop     WndClass.hInstance
        mov     WndClass.hIcon, esi         
	invoke  LoadCursor, 0, IDC_ARROW
        mov     WndClass.hCursor, eax
	push	S("scroll")
        pop     WndClass.lpszClassName
        mov     WndClass.hbrBackground, COLOR_BTNFACE+1
        invoke  RegisterClassA, addr WndClass         
	
	mov	w_, 300
	mov	h_, 156
	invoke	GetSystemMetrics,SM_CXSCREEN
	invoke	TopXY,w_,eax
	mov	x_, eax
	invoke	GetSystemMetrics,SM_CYSCREEN
	invoke	TopXY,h_,eax
	mov	y_, eax

	invoke  CreateWindowExA,NULL,S("scroll"), S("Bitmaps Scroll"),\
		WS_MINIMIZEBOX or WS_SYSMENU or WS_OVERLAPPED,\
		x_,y_,w_,h_,NULL,NULL,hInstance,NULL
	mov     hWnd,eax
		
	invoke	LoadIcon,hInstance, 999
	invoke	SendMessage, hWnd, WM_SETICON, ICON_SMALL or ICON_BIG, eax
	
	invoke  ShowWindow,hWnd,SW_SHOW
	invoke  UpdateWindow,hWnd
        
	.while TRUE                          
		invoke  GetMessageA, addr Msg, esi, esi, esi
		.break .if (!eax)
		invoke  TranslateMessage, addr Msg                                              
		invoke  DispatchMessageA, addr Msg                                
        .endw                                      
        mov eax, Msg.wParam
        ret

WinMain endp

start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke InitCommonControls			
	invoke WinMain,NULL
	invoke ExitProcess,eax


end start
